dnl $Id: config.m4,v 1.3 2004/10/05 16:02:36 areaz2 Exp $
dnl config.m4 for extension dazuko

dnl If your extension references something external, use with:

PHP_ARG_WITH(dazuko, for dazuko support, [  --with-dazuko           Include dazuko support (add path of dazuko src)])

if test "$PHP_DAZUKO" != "no"; then

  # --with-dazuko -> check with-path
  SEARCH_PATH="/usr/local/include /usr/include"
  SEARCH_FOR="dazukoio.h"
  if test -r $PHP_DAZUKO/$SEARCH_FOR; then # path given as parameter
    DAZUKO_DIR=$PHP_DAZUKO
  else # search default path list
    AC_MSG_CHECKING([for dazuko files in default path])
    for i in $SEARCH_PATH ; do
      if test -r $i/$SEARCH_FOR; then
        DAZUKO_DIR=$i
        AC_MSG_RESULT(found in $i)
      fi
    done
  fi
  
  if test -z "$DAZUKO_DIR"; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([Please reinstall the dazuko distribution])
  fi

  # --with-dazuko -> add include path
  PHP_ADD_INCLUDE($DAZUKO_DIR)

  # --with-dazuko -> check for lib and symbol presence
  LIBNAME=dazuko
  LIBSYMBOL=dazukoRegister 

  PHP_CHECK_LIBRARY($LIBNAME,$LIBSYMBOL,
  [
    PHP_ADD_LIBRARY_WITH_PATH($LIBNAME, $DAZUKO_DIR/library, DAZUKO_SHARED_LIBADD)
    AC_DEFINE(HAVE_DAZUKOLIB,1,[ ])
  ],[
    AC_MSG_ERROR([wrong dazuko lib version or lib not found])
  ],[
    -L$DAZUKO_DIR/lib -lm -ldl
  ])
  
  PHP_SUBST(DAZUKO_SHARED_LIBADD)

  PHP_NEW_EXTENSION(dazuko, dazuko.c, $ext_shared)
fi
