<? // Tiny dazuko multi threaded API example

/* Simply run with: php -q <scriptname> */

/* Check if the dazuko module is loaded and accessable */
if (dazuko_module_loaded() == false) {
   echo "Kernel module inaccessable\n";
   echo "Do you need to insmod first?\n";
   echo "Or is /dev/dazuko missing?\n";
   exit (2);
}

/* Register a dazuko thread in read-only mode */
$t_id = dazuko_thread_register("Testapplication_MT","r");

if (is_resource($t_id) == false) {
   echo "Unable to register dazuko thread\n";
   exit (1);
}

/* Add exclude and include paths */
if (dazuko_thread_exclude_path($t_id,"/dev/null") == false) {
   echo "Unable to exclude /dev/null\n";
   exit (3);
} else {
   dazuko_thread_include_path($t_id,"/etc");
}

$maxruntime = time()+120;

while ($maxruntime>time()) {
   
   /* Wait for access */
   if ($r_id = dazuko_thread_get_access($t_id)) {
      
      /* Fetch result resource */
      $array = dazuko_fetch_result($r_id);

      /* Print it ;-) */
      print_r($array);
   }
}

/* Time is over, print thread info, flush and unregister */
$threadinfo = dazuko_fetch_thread($t_id);
print_r($threadinfo);

dazuko_flush_result($r_id);
dazuko_thread_unregister($t_id);
?>