<? // Dazuko single threaded API

/* HOW TO USE:
   Execute this script with: php -q <scriptname>
   Do some stuff in /tmp/dazukopermit and /tmp/dazukodeny
   after you have created this directories (create directories,
   before you start this script)
   Watch, what this script is telling you ;-) */

/* Check if the dazuko module is loaded and accessable */
if (dazuko_module_loaded() == false) {
   echo "Kernel module inaccessable\n";
   echo "Do you need to insmod first?\n";
   echo "Or is /dev/dazuko missing?\n";
   exit (2);
}

/* Register with dazuko in read-write mode, exit on failure */
if (dazuko_register("Testapplication","r+")) {

   /* Set the accessmask */
   if (dazuko_set_accessmask(DAZUKO_ALL_EVENTS) == false) {
      echo "Unable to set accessmask\n";
      dazuko_unregister();
      exit (3);
   }
   
   /* Add paths to watching and exclude list */
   if (dazuko_exclude_path("/dev/null") == false) {
      echo "Unable to add exclude path /dev/null\n";
      dazuko_unregister();
      exit (3);
   } else {
      /* Watch /tmp/dazukopermit and /tmp/dazukodeny */

      dazuko_include_path("/tmp/dazukopermit");
      dazuko_include_path("/tmp/dazukodeny");
   }

   $maxruntime = time()+120;

   while ($maxruntime>time()) {
   
      /* Wait for access */
      if ($r_id = dazuko_get_access()) {

         /* Fetch the result array */
         $array = dazuko_fetch_result($r_id);

         /* Extract directory, where event happened */
         $filename = $array[file_name];
         $directory = dirname($filename);

         /* Deny access in /tmp/dazukodeny and permit all other */
         if (ereg("^/tmp/dazukodeny",$directory)) {
            dazuko_return_access($r_id,DAZUKO_DENY);

            echo "Denied access in $directory\n";
         } else {
            dazuko_return_access($r_id,DAZUKO_PERMIT);

            echo "Granted access in $directory\n";
         }

         /* Print result array and current time */
         print_r($array);
         echo "---".date("r")."---\n\n";
      }
   }

   /* Time is over, unregister */
   dazuko_unregister();
} else {
   echo "Unable to register with dazuko\n";
   exit (1);
}
?>